var O = Object.defineProperty;
var x = (e) => {
  throw TypeError(e);
};
var v = (e, t, r) => t in e ? O(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r;
var o = (e, t, r) => v(e, typeof t != "symbol" ? t + "" : t, r), N = (e, t, r) => t.has(e) || x("Cannot " + r);
var T = (e, t, r) => (N(e, t, "read from private field"), r ? r.call(e) : t.get(e)), p = (e, t, r) => t.has(e) ? x("Cannot add the same private member more than once") : t instanceof WeakSet ? t.add(e) : t.set(e, r), E = (e, t, r, s) => (N(e, t, "write to private field"), s ? s.call(e, r) : t.set(e, r), r);
var l = /* @__PURE__ */ ((e) => (e[e.TIMEOUT = 1] = "TIMEOUT", e[e.MAX_RETRY_FAILED = 2] = "MAX_RETRY_FAILED", e[e.ABORT = 3] = "ABORT", e))(l || {}), c = /* @__PURE__ */ ((e) => (e[e.PENDING = 0] = "PENDING", e[e.FULFILLED = 1] = "FULFILLED", e[e.REJECTED = 2] = "REJECTED", e))(c || {});
const A = {
  [l.TIMEOUT]: "超时",
  [l.MAX_RETRY_FAILED]: "最大重试次数失败",
  [l.ABORT]: "中止"
};
class R extends Error {
  constructor(t, r = A[t]) {
    super(r), this.code = t;
  }
}
let G = 0;
const j = (e, t) => (r, s) => {
  t.resolveWrap = (i) => {
    if (t.state !== c.PENDING) {
      console.log(`当前状态已经变为${t.state}, 忽略resolve`);
      return;
    }
    t.endTime = Date.now(), console.log(
      `${t.index} 调用成功${t.num++}次`,
      i,
      `耗时${t.endTime - t.startTime}ms`
    ), t.state = c.FULFILLED, t.clearTimeoutTimer(), r(i);
  }, t.rejectWrap = (i) => {
    if (t.state !== c.PENDING) {
      console.log(`当前状态已经变为${t.state}, 忽略reject`);
      return;
    }
    t.endTime = Date.now(), console.log(
      `${t.index} 调用失败${t.num++}次`,
      i,
      `耗时${t.endTime - t.startTime}ms`
    ), t.state = c.REJECTED, t.clearTimeoutTimer(), s(i);
  }, e(t.resolveWrap, t.rejectWrap);
}, U = (e) => {
  const t = {
    timeoutTimer: void 0,
    clearTimeoutTimer() {
      this.timeoutTimer && (clearTimeout(this.timeoutTimer), this.timeoutTimer = void 0);
    },
    startTime: Date.now(),
    state: c.PENDING,
    num: 0,
    index: G++
  }, r = j(e, t);
  return t.promise = new Promise(r), t.promise.catch((s) => {
    var i;
    return t.state === c.PENDING && (console.log("promise 内部出现pending状态错误", s), (i = t.rejectWrap) == null || i.call(t, s)), s;
  }), {
    baseInfo: t
  };
}, W = (e) => {
  let t;
  return {
    applyPromise: () => (t || (t = e(), t.catch(() => {
      t = void 0, console.log("Promise sharing: promise出错，已重置");
    })), t)
  };
};
class B extends R {
  constructor(t) {
    const r = t.length;
    super(
      l.MAX_RETRY_FAILED,
      `执行${r}次(重试${r - 1}次)，最终仍失败`
    ), this.errorList = t;
  }
}
const P = (e, {
  maxRetry: t,
  getDelay: r = () => 0
}) => {
  let s = 0;
  t < 0 && console.error("最大重试次数不能小于0， 此处将使用默认值 0");
  const i = Math.max(t, 0), g = [];
  return new Promise((y, F) => {
    const h = () => {
      e().then(y).catch((M) => {
        if (g.push(M), s < i) {
          s++;
          const w = r(s);
          w > 0 ? setTimeout(h, w) : h();
        } else
          F(new B(g));
      });
    };
    h();
  });
};
class $ extends R {
  constructor(t = A[l.ABORT]) {
    super(l.ABORT, t);
  }
}
var m;
const u = class u {
  constructor(t) {
    /** promise原始reject函数 */
    p(this, m);
    E(this, m, t);
  }
  /** 取消 promise */
  cancel(t) {
    T(this, m).call(this, t);
  }
};
m = new WeakMap(), /** 是否取消错误 */
o(u, "isCancelError", (t) => t instanceof $), /** 创建 promise 取消令牌 */
o(u, "source", (t) => new u(t));
let D = u;
var L, n;
L = Symbol.toStringTag;
const a = class a {
  constructor(t) {
    o(this, L, `object ${a.name}`);
    /** 原始promise上下文 */
    p(this, n);
    /** 超时设置 */
    o(this, "timeout", (t) => {
      const { baseInfo: r } = T(this, n);
      if (r.state !== c.PENDING)
        return console.warn("超时设置失败，promise状态不为pending"), this;
      r.clearTimeoutTimer();
      const s = Math.max(0, r.startTime + t - Date.now());
      return console.log(`超时设置${t}ms, 剩余${s}ms`), r.timeoutTimer = setTimeout(() => {
        console.log("走到超时时刻"), r.rejectWrap(new R(l.TIMEOUT));
      }, s), this;
    });
    /** 中止promise */
    o(this, "abort", (t) => {
      const { baseInfo: r } = T(this, n);
      return r.state !== c.PENDING ? (console.warn("取消失败，promise状态不为pending"), this) : (D.source((i) => {
        r.rejectWrap(new $(i));
      }).cancel(t), this);
    });
    E(this, n, U(t));
  }
  // 修正 then 方法
  then(t, r) {
    return new a((s, i) => {
      T(this, n).baseInfo.promise.then(t, r).then(s, i);
    });
  }
  // 修正 catch 方法
  catch(t) {
    return this.then(void 0, t);
  }
  // 修正 finally 方法
  finally(t) {
    return new a((r, s) => {
      T(this, n).baseInfo.promise.finally(t).then(r, s);
    });
  }
};
n = new WeakMap(), /** promise共享 */
o(a, "useSharing", W), /** promise重试 */
o(a, "retry", P);
let d = a;
export {
  d as XPromise,
  R as XPromiseError,
  l as XPromiseErrorCodeEnum
};
